import * as t from '@babel/types';
import { NodePath } from '@babel/core';
import { Metadata } from '../types';
/**
 * Takes a JSX opening element and then transforms any usage of `css` prop to a compiled component.
 *
 * `<div css={{}}>`
 *
 * @param path Babel path - expects to be a JSX opening element.
 * @param state Babel state - should house options and meta data used during the transformation.
 */
export declare const visitCssPropPath: (path: NodePath<t.JSXOpeningElement>, meta: Metadata) => void;
